//|Xg|CgCgpGtFNg
//--ρFr[}P

////////////////////////////////////////////////////////////////////////////////////////////////
//
//  full.fx ver1.0
//  쐬: ͉P
//
//   PointLightpɉ(by ɖkP)
//
////////////////////////////////////////////////////////////////////////////////////////////////

//----
// _֘A

//----

// p[^錾
// Wϊs
float4x4 WorldViewProjMatrix      : WORLDVIEWPROJECTION;
float4x4 WorldMatrix              : WORLD;
float4x4 ViewMatrix               : VIEW;
float4x4 LightWorldViewProjMatrix : WORLDVIEWPROJECTION < string Object = "Light"; >;

float3   LightDirection    : DIRECTION < string Object = "Light"; >;
float3   CameraPosition    : POSITION  < string Object = "Camera"; >;

// }eAF
float4   MaterialDiffuse   : DIFFUSE  < string Object = "Geometry"; >;
float3   MaterialAmbient   : AMBIENT  < string Object = "Geometry"; >;
float3   MaterialEmmisive  : EMISSIVE < string Object = "Geometry"; >;
float3   MaterialSpecular  : SPECULAR < string Object = "Geometry"; >;
float    SpecularPower     : SPECULARPOWER < string Object = "Geometry"; >;
float3   MaterialToon      : TOONCOLOR;
// CgF
float3   LightDiffuse      : DIFFUSE   < string Object = "Light"; >;
float3   LightAmbient      : AMBIENT   < string Object = "Light"; >;
float3   LightSpecular     : SPECULAR  < string Object = "Light"; >;
static float4 DiffuseColor  = MaterialDiffuse;
static float3 AmbientColor  = MaterialAmbient  * MaterialEmmisive;
static float3 SpecularColor = MaterialSpecular;

bool     parthf;   // p[XyNeButO
bool     transp;   // tO
bool	 spadd;    // XtBA}bvZtO
#define SKII1    1500
#define SKII2    8000
#define Toon     3

// IuWFNg̃eNX`
texture ObjectTexture: MATERIALTEXTURE;
sampler ObjTexSampler = sampler_state {
    texture = <ObjectTexture>;
    MINFILTER = LINEAR;
    MAGFILTER = LINEAR;
    AddressU	= WRAP;
    AddressV	= WRAP;
};

// XtBA}bṽeNX`
texture ObjectSphereMap: MATERIALSPHEREMAP;
sampler ObjSphareSampler = sampler_state {
    texture = <ObjectSphereMap>;
    MINFILTER = LINEAR;
    MAGFILTER = LINEAR;
};

float3 ControllerPos : CONTROLOBJECT < string name = "(OffscreenOwner)"; string item = "Z^["; >;
float morph_r : CONTROLOBJECT < string name = "(OffscreenOwner)"; string item = ""; >;
float morph_g : CONTROLOBJECT < string name = "(OffscreenOwner)"; string item = ""; >;
float morph_b : CONTROLOBJECT < string name = "(OffscreenOwner)"; string item = ""; >;
float morph_scale : CONTROLOBJECT < string name = "(OffscreenOwner)"; string item = ""; >;
float morph_g_scale : CONTROLOBJECT < string name = "(OffscreenOwner)"; string item = "͈͊g"; >;

// _̌W
inline float PointLightCf(float4 d, float4 cf, float pw)
{
    return pw * cf.a / (cf.x + cf.y*d + cf.z*d*d );
}
float time_0_X : Time;
// _̐F
float3 PointLightColor(float4 p, float3 n)
{
    float3 col = float3(0,0,0);
	float4 PL1_Cf = float4(0,1,0,1);
	float PL1_Power = 1;
	float PL1_Scaling = (1-morph_scale)*32*(1+morph_g_scale*64);
	float3 PL1_Color = float3(1-morph_r,1-morph_g,1-morph_b);
    col += max(0,dot( n, normalize(ControllerPos - p) )) * 0.2 * PointLightCf(length(p - ControllerPos), PL1_Cf, PL1_Power) * PL1_Scaling * PL1_Color;

    return col;
    
}

//----


////////////////////////////////////////////////////////////////////////////////////////////////
// ֊s`

// _VF[_
float4 ColorRender_VS(float4 Pos : POSITION) : POSITION 
{
    // J_̃[hr[ˉeϊ
    return mul( Pos, WorldViewProjMatrix );
}

// sNZVF[_
float4 ColorRender_PS() : COLOR
{
    // œhԂ
    return float4(0,0,0,1);
}

// ֊s`peNjbN
technique EdgeTec < string MMDPass = "edge"; > {
    pass DrawEdge {
        AlphaBlendEnable = FALSE;
        AlphaTestEnable  = FALSE;

        VertexShader = compile vs_3_0 ColorRender_VS();
        PixelShader  = compile ps_3_0 ColorRender_PS();
    }
}


///////////////////////////////////////////////////////////////////////////////////////////////
// eiZtVhEj`

// _VF[_
float4 Shadow_VS(float4 Pos : POSITION) : POSITION
{
    // J_̃[hr[ˉeϊ
    return mul( Pos, WorldViewProjMatrix );
}

// sNZVF[_
float4 Shadow_PS() : COLOR
{
    // ArGgFœhԂ
    return float4(AmbientColor.rgb, 0.65f);
}

// e`peNjbN
technique ShadowTec < string MMDPass = "shadow"; > {
    pass DrawShadow {
        VertexShader = compile vs_3_0 Shadow_VS();
        PixelShader  = compile ps_3_0 Shadow_PS();
    }
}


///////////////////////////////////////////////////////////////////////////////////////////////
// IuWFNg`iZtVhEOFFj

struct VS_OUTPUT {
    float4 Pos        : POSITION;    // ˉeϊW
    float2 Tex        : TEXCOORD1;   // eNX`
    float3 Normal     : TEXCOORD2;   // @
    float3 Eye        : TEXCOORD3;   // JƂ̑Έʒu
    float2 SpTex      : TEXCOORD4;	 // XtBA}bveNX`W
    float4 LastPos	  : TEXCOORD5;	 // ϊςݍW
    float4 Color      : COLOR0;      // fBt[YF
};

// _VF[_
VS_OUTPUT Basic_VS(float4 Pos : POSITION, float3 Normal : NORMAL, float2 Tex : TEXCOORD0, out float3 plCol : TEXCOORD5, uniform bool useTexture, uniform bool useSphereMap, uniform bool useToon)
{
    VS_OUTPUT Out = (VS_OUTPUT)0;
    
    // J_̃[hr[ˉeϊ
    Out.Pos = mul( Pos, WorldViewProjMatrix );
    
    // JƂ̑Έʒu
    Out.Eye = CameraPosition - mul( Pos, WorldMatrix );
    // _@
    Out.Normal = normalize( mul( Normal, (float3x3)WorldMatrix ) );
    
    Out.Color = 1;
    
    // eNX`W
    Out.Tex = Tex;
    
    if ( useSphereMap ) {
        // XtBA}bveNX`W
        float2 NormalWV = mul( Out.Normal, (float3x3)ViewMatrix );
        Out.SpTex.x = NormalWV.x * 0.5f + 0.5f;
        Out.SpTex.y = NormalWV.y * -0.5f + 0.5f;
    }
    
    Out.LastPos = Pos;



    return Out;
}

// sNZVF[_
float4 Basic_PS(VS_OUTPUT IN, float3 plCol : TEXCOORD5, uniform bool useTexture, uniform bool useSphereMap, uniform bool useToon) : COLOR0
{
	float3 LightCol = float3(1-morph_r,1-morph_g,1-morph_b);
	
	float4 wDiffuseColor  = MaterialDiffuse  * float4(LightDiffuse, 1.0f);
	float3 wAmbientColor  = MaterialAmbient  * LightCol + MaterialEmmisive;
	float3 wSpecularColor = MaterialSpecular * LightCol;
    float3 wLightDirection = normalize(IN.LastPos - ControllerPos);
    // _̌
    float4 pp = mul(IN.LastPos,WorldMatrix);
    plCol = PointLightColor(pp/pp.w, IN.Normal);
	
    // XyLFvZ
    float3 HalfVector = normalize( normalize(IN.Eye) + -wLightDirection );
    float3 Specular = pow( max(0,dot( HalfVector, normalize(IN.Normal) )), SpecularPower ) * wSpecularColor;
    
    float4 Color = IN.Color;
    
    // fBt[YF{ArGgF vZ
    Color.rgb = AmbientColor;
    if ( !useToon ) {
        Color.rgb += max(0,dot( IN.Normal, -wLightDirection )) * DiffuseColor.rgb;
    }
    Color.a = DiffuseColor.a;
    Color = saturate( Color );
    
    if ( useTexture ) {
        // eNX`Kp
        Color *= tex2D( ObjTexSampler, IN.Tex );
    }
    if ( useSphereMap ) {
        // XtBA}bvKp
        if(spadd) Color.rgb += tex2D(ObjSphareSampler,IN.SpTex).rgb;
        else      Color.rgb *= tex2D(ObjSphareSampler,IN.SpTex).rgb;
    }
    
    if ( useToon ) {
        // gD[Kp
        float LightNormal = dot( IN.Normal, -wLightDirection );
        Color.rgb *= lerp(MaterialToon, float3(1,1,1), saturate(LightNormal * 16 + 0.5));
    }
    
    // XyLKp
    Color.rgb += Specular;
    Color.rgb *= plCol;
    return Color;
}

// IuWFNg`peNjbNiANZTpj
// svȂ͍̂폜
technique MainTec0 < string MMDPass = "object"; bool UseTexture = false; bool UseSphereMap = false; bool UseToon = false; > {
    pass DrawObject {
        VertexShader = compile vs_3_0 Basic_VS(false, false, false);
        PixelShader  = compile ps_3_0 Basic_PS(false, false, false);
    }
}

technique MainTec1 < string MMDPass = "object"; bool UseTexture = true; bool UseSphereMap = false; bool UseToon = false; > {
    pass DrawObject {
        VertexShader = compile vs_3_0 Basic_VS(true, false, false);
        PixelShader  = compile ps_3_0 Basic_PS(true, false, false);
    }
}

technique MainTec2 < string MMDPass = "object"; bool UseTexture = false; bool UseSphereMap = true; bool UseToon = false; > {
    pass DrawObject {
        VertexShader = compile vs_3_0 Basic_VS(false, true, false);
        PixelShader  = compile ps_3_0 Basic_PS(false, true, false);
    }
}

technique MainTec3 < string MMDPass = "object"; bool UseTexture = true; bool UseSphereMap = true; bool UseToon = false; > {
    pass DrawObject {
        VertexShader = compile vs_3_0 Basic_VS(true, true, false);
        PixelShader  = compile ps_3_0 Basic_PS(true, true, false);
    }
}

// IuWFNg`peNjbNiPMDfpj
technique MainTec4 < string MMDPass = "object"; bool UseTexture = false; bool UseSphereMap = false; bool UseToon = true; > {
    pass DrawObject {
        VertexShader = compile vs_3_0 Basic_VS(false, false, true);
        PixelShader  = compile ps_3_0 Basic_PS(false, false, true);
    }
}

technique MainTec5 < string MMDPass = "object"; bool UseTexture = true; bool UseSphereMap = false; bool UseToon = true; > {
    pass DrawObject {
        VertexShader = compile vs_3_0 Basic_VS(true, false, true);
        PixelShader  = compile ps_3_0 Basic_PS(true, false, true);
    }
}

technique MainTec6 < string MMDPass = "object"; bool UseTexture = false; bool UseSphereMap = true; bool UseToon = true; > {
    pass DrawObject {
        VertexShader = compile vs_3_0 Basic_VS(false, true, true);
        PixelShader  = compile ps_3_0 Basic_PS(false, true, true);
    }
}

technique MainTec7 < string MMDPass = "object"; bool UseTexture = true; bool UseSphereMap = true; bool UseToon = true; > {
    pass DrawObject {
        VertexShader = compile vs_3_0 Basic_VS(true, true, true);
        PixelShader  = compile ps_3_0 Basic_PS(true, true, true);
    }
}

// IuWFNg`peNjbNiANZTpj
technique MainTecBS0  < string MMDPass = "object_ss"; bool UseTexture = false; bool UseSphereMap = false; bool UseToon = false; > {
    pass DrawObject {
        VertexShader = compile vs_3_0 Basic_VS(false, false, false);
        PixelShader  = compile ps_3_0 Basic_PS(false, false, false);
    }
}

technique MainTecBS1  < string MMDPass = "object_ss"; bool UseTexture = true; bool UseSphereMap = false; bool UseToon = false; > {
    pass DrawObject {
        VertexShader = compile vs_3_0 Basic_VS(true, false, false);
        PixelShader  = compile ps_3_0 Basic_PS(true, false, false);
    }
}

technique MainTecBS2  < string MMDPass = "object_ss"; bool UseTexture = false; bool UseSphereMap = true; bool UseToon = false; > {
    pass DrawObject {
        VertexShader = compile vs_3_0 Basic_VS(false, true, false);
        PixelShader  = compile ps_3_0 Basic_PS(false, true, false);
    }
}

technique MainTecBS3  < string MMDPass = "object_ss"; bool UseTexture = true; bool UseSphereMap = true; bool UseToon = false; > {
    pass DrawObject {
        VertexShader = compile vs_3_0 Basic_VS(true, true, false);
        PixelShader  = compile ps_3_0 Basic_PS(true, true, false);
    }
}

// IuWFNg`peNjbNiPMDfpj
technique MainTecBS4  < string MMDPass = "object_ss"; bool UseTexture = false; bool UseSphereMap = false; bool UseToon = true; > {
    pass DrawObject {
        VertexShader = compile vs_3_0 Basic_VS(false, false, true);
        PixelShader  = compile ps_3_0 Basic_PS(false, false, true);
    }
}

technique MainTecBS5  < string MMDPass = "object_ss"; bool UseTexture = true; bool UseSphereMap = false; bool UseToon = true; > {
    pass DrawObject {
        VertexShader = compile vs_3_0 Basic_VS(true, false, true);
        PixelShader  = compile ps_3_0 Basic_PS(true, false, true);
    }
}

technique MainTecBS6  < string MMDPass = "object_ss"; bool UseTexture = false; bool UseSphereMap = true; bool UseToon = true; > {
    pass DrawObject {
        VertexShader = compile vs_3_0 Basic_VS(false, true, true);
        PixelShader  = compile ps_3_0 Basic_PS(false, true, true);
    }
}

technique MainTecBS7  < string MMDPass = "object_ss"; bool UseTexture = true; bool UseSphereMap = true; bool UseToon = true; > {
    pass DrawObject {
        VertexShader = compile vs_3_0 Basic_VS(true, true, true);
        PixelShader  = compile ps_3_0 Basic_PS(true, true, true);
    }
}


///////////////////////////////////////////////////////////////////////////////////////////////
